﻿using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
using System.Configuration;

 
    public class DataManager
    {
        static Database database = null;

        public DataManager(string cs)
        {
            database = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(
                ConfigurationManager.ConnectionStrings[cs].ConnectionString);
            //database = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(cs);
        }        

        public DataSet ExecuteDs(string storedProcedureName, params object[] parameterValues)
        {
            using (DbConnection sqlConnection = database.CreateConnection())
            {
                using (DbCommand sqlCommand = database.GetStoredProcCommand(storedProcedureName, parameterValues))
                {
                    sqlConnection.Open();
                    sqlCommand.CommandType = CommandType.StoredProcedure;
                    sqlCommand.CommandTimeout = 90;
                    sqlCommand.Connection = sqlConnection;

                    try
                    {
                        DataSet ds = new DataSet();
                        ds.EnforceConstraints = false;
                        DbDataAdapter sqlda = database.GetDataAdapter();
                        sqlda.SelectCommand = sqlCommand;
                        sqlda.Fill(ds);
                        return ds;
                    }
                    catch (Exception Ex)
                    {
                        throw (Ex);
                    }

                }
            }
        }

        public DataTable ExecuteDt(string storedProcedureName, params object[] parameterValues)
        {
            using (DbConnection sqlConnection = database.CreateConnection())
            {
                using (DbCommand sqlCommand = database.GetStoredProcCommand(storedProcedureName, parameterValues))
                {
                    sqlConnection.Open();
                    sqlCommand.CommandType = CommandType.StoredProcedure;
                    sqlCommand.CommandTimeout = 90;
                    sqlCommand.Connection = sqlConnection;

                    try
                    {
                        DataTable dt = new DataTable("Table");
                        DbDataAdapter sqlda = database.GetDataAdapter();
                        sqlda.SelectCommand = sqlCommand;
                        dt.BeginLoadData();
                        sqlda.Fill(dt);
                        dt.EndLoadData();
                        return dt;
                    }
                    catch (Exception Ex)
                    {
                        throw (Ex);
                    }

                }
            }
        }

        public object ExecuteSc(string SP, params object[] prm)
        {
            using (DbConnection sqlConnection = database.CreateConnection())
            {
                using (DbCommand sqlCommand = database.GetStoredProcCommand(SP, prm))
                {
                    try
                    {
                        sqlConnection.Open();
                        sqlCommand.CommandType = CommandType.StoredProcedure;
                        sqlCommand.CommandTimeout = 90;
                        sqlCommand.Connection = sqlConnection;

                        return sqlCommand.ExecuteScalar();
                    }
                    catch (Exception Ex)
                    {
                        throw (Ex);
                    }
                }
            }

        }

        public object ExecuteNq(string SP, params object[] prm)
        {
            using (DbConnection sqlConnection = database.CreateConnection())
            {
                using (DbCommand sqlCommand = database.GetStoredProcCommand(SP, prm))
                {
                    try
                    {
                        sqlConnection.Open();
                        sqlCommand.CommandType = CommandType.StoredProcedure;
                        sqlCommand.CommandTimeout = 90;
                        sqlCommand.Connection = sqlConnection;

                        return sqlCommand.ExecuteNonQuery();
                    }
                    catch (Exception Ex)
                    {
                        throw (Ex);
                    }
                }
            }

        }
        

    }
