﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;

public partial class Controls_Articles : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        int tip = QueryStrings.Tip;
        switch (tip)
        {
            case 1:
                lblHeader.Text = "Tüm Makaleler";                
                break;
            case 2:
                lblHeader.Text = "Son Eklenen Makaleler";                
                break;
            case 3:
                lblHeader.Text = "En Çok Okunan Makaleler";                
                break;
            case 4:
                lblHeader.Text = "En Çok Yorumlanan Makaleler";                
                break;
        }

        if (!this.IsPostBack)
        {
            gvUzun.Visible = (tip == 1);
            rpKisa.Visible = !gvUzun.Visible;
            txtFiltre.Attributes.Add("onkeyup", "__doPostBack('" + updatePanel.ClientID + "','')");
        }
        else
        {
            string target = this.Request.Form["__EVENTTARGET"];
            String sEventArguments = this.Request.Params["__EVENTARGUMENT"];
            
            if (sEventArguments != null && sEventArguments != string.Empty)
                txtFiltre.Text = sEventArguments;

            if (sEventArguments != null && sEventArguments == "Temizle")
                txtFiltre.Text = "";


            if (!string.IsNullOrEmpty(target) && target.Equals(this.updatePanel.ClientID))
            {
                sqlDs.SelectParameters["Filtre"].DefaultValue = "%" + txtFiltre.Text + "%";
                if (tip == 1)                
                    gvUzun.DataBind();                
                else
                    rpKisa.DataBind();
            }
        }
    }

    public string GetTags(string tagList)
    {
        if (tagList == string.Empty)
            return "";
        string[] tags = tagList.Split(',');
        string result = string.Empty;
        foreach (string t in tags)
        {
            string tag = t.Trim();            
            result += @"<a href='#' onclick=""__doPostBack('" + updatePanel.ClientID + "','" + tag + @"');document.getElementById('" + txtFiltre.ClientID + "').innerText = '" + tag + @"';"">" + tag + "</a>&nbsp;";        
        }
        
        return @"<img id=""Img2""  src=""/App_themes/standart/images/tag.jpg"" /> " + result + " | ";
    }

    public string GetTemizleLink()
    {
        string tag = "Temizle";
        string result = @"<a href='#' onclick=""__doPostBack('" + updatePanel.ClientID + "','" + tag + @"');document.getElementById('" + txtFiltre.ClientID + "').innerText = '" + "" + @"';"">" + tag + "</a>";
        return result;
    }

    public string ImageUrl(object MakaleId)
    {
        string url = "App_Themes/Standart/Articles/";
        string path = Server.MapPath(url + "specific/" + MakaleId.ToString() + ".jpg");
        if (File.Exists(path))
            return url + "specific/" + MakaleId.ToString() + ".jpg";
        else
        {
            string[] files = System.IO.Directory.GetFiles(Server.MapPath(url + "random/"));

            int index = int.Parse(MakaleId.ToString()) % files.Length;
            FileInfo fi = new FileInfo(files[index]);

            return url + "random/" + fi.Name;
        }
    }

    protected void btnTag_Click(object sender, EventArgs e)
    {
        txtFiltre.Text = "test";
    }
    
    protected void cmbSiralama_SelectedIndexChanged(object sender, EventArgs e)
    {
       //  string column = ((LinkButton)sender).CommandArgument;
        DevExpress.Data.ColumnSortOrder so = DevExpress.Data.ColumnSortOrder.Ascending;
        if (cmbSortOrder.SelectedItem.Value.ToString() == "desc")
            so = DevExpress.Data.ColumnSortOrder.Descending;
        
        //if (ViewState[column] == null || ViewState[column].ToString() == "ASC")
        //{
        //    so = DevExpress.Data.ColumnSortOrder.Ascending;
        //    ViewState[column] = "DESC";
        //}
        //else if (ViewState[column].ToString() == "DESC")
        //{
        //    so = DevExpress.Data.ColumnSortOrder.Descending;
        //    ViewState[column] = "ASC";
        //}

        gvUzun.SortBy(gvUzun.Columns["Tarih"], DevExpress.Data.ColumnSortOrder.None);
        gvUzun.SortBy(gvUzun.Columns["Baslik"], DevExpress.Data.ColumnSortOrder.None);
        gvUzun.SortBy(gvUzun.Columns["Hit"],DevExpress.Data.ColumnSortOrder.None);

        gvUzun.SortBy(gvUzun.Columns[cmbSiralama.SelectedItem.Value.ToString()], so);
        gvUzun.DataBind();
    }
    protected void cmbSayfalama_SelectedIndexChanged(object sender, EventArgs e)
    {
        int pageSize  = int.Parse(cmbSayfalama.SelectedItem.Value.ToString());
        if (pageSize > 0)
            gvUzun.SettingsPager.PageSize = pageSize;
        else
            gvUzun.SettingsPager.PageSize= int.MaxValue;

        gvUzun.DataBind();
    }
    protected void lnkTemizle_Click(object sender, EventArgs e)
    {
        int tip = QueryStrings.Tip;
        txtFiltre.Text = "";
        sqlDs.SelectParameters["Filtre"].DefaultValue = "%" + txtFiltre.Text + "%";
        if (tip == 1)
            gvUzun.DataBind();
        else
            rpKisa.DataBind();
    }
}