﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

public partial class Controls_Login : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {       
        if (!Page.IsPostBack)
        {            
            string action = QueryStrings.Oturum;
            
            if (action.ToLower() == "ac")
            {
                pnlLogin.Visible = true;
                pnlYeniUye.Visible = false;
                pnlForgetPassword.Visible = false;
            }
            else if (action.ToLower() == "yeni")
            {
                pnlLogin.Visible = false;
                pnlYeniUye.Visible = true;
                pnlForgetPassword.Visible = false;

                txtAdSoyad.Text = string.Empty;
                txtYeniEposta.Text = string.Empty;
                txtKullaniciAdi.Text = string.Empty;                
            }           
            else
            {
                this.Visible = false;
            }

            if (Cookies.Eposta != string.Empty)
                Login(Cookies.Eposta, "*");
        }
    }


    protected void btnGiris_Click(object sender, EventArgs e)
    {
        Login(txtEposta.Text, txtParola.Text);
    }

    private void Login(string Eposta, string Parola)
    {
        Uye uye = Uye.Get(Eposta, Parola);

        if (uye.UyeId != -1)
        {
            Sessions.Uye = uye;
            Cookies.Eposta = txtEposta.Text;
            
            if ( QueryStrings.Geri != string.Empty)
            {
                Response.Redirect(QueryStrings.Geri);
            }
            else if (uye.YoneticiMi)
                Response.Redirect("Admin/Default.aspx");
            else
            {
                Response.Redirect("~/Default.aspx");
            }
        }
        else //Hatalı kullanıcı adı
        {
            pnlLogin.Visible = true;
            lblInfo.Visible = true;
            
            pnlYeniUye.Visible = false;
            pnlForgetPassword.Visible = false;            
        }            
    }


    protected void btnKaydet_Click(object sender, EventArgs e)
    {
        Uye uye = new Uye();
        uye.KullaniciAdi = txtKullaniciAdi.Text;
        uye.AdSoyad = txtAdSoyad.Text;
        uye.Eposta = txtYeniEposta.Text;
        uye.Parola = txtYeniParola.Text;
        uye.MakaleAlarm = chkMakaleAlarm.Checked;
        uye.YorumAlarm = chkYorumAlarm.Checked;
        uye.Kaydet();
        Sessions.Uye = uye;
        Cookies.Eposta = txtYeniEposta.Text;
        Login(uye.Eposta, uye.Parola);
        Response.Redirect("~/Default.aspx");
    }

    protected void btnSifremiUnuttum_Click(object sender, EventArgs e)
    {
        pnlForgetPassword.Visible = true;
        pnlLogin.Visible = false;
        pnlYeniUye.Visible = false;
    }

    protected void btnSifremiGonder_Click(object sender, EventArgs e)
    {
        Uye uye = Uye.Get(txtSifreEposta.Text);
        
        if (uye.UyeId == -1)
        {
            lblSifreInfo.Text = "Belirttiğiniz eposta adresiniz sistemimizde mevcut değildir. Tekrar deneyiniz.";
        }
        else
        {
            string body = "Sayın " + uye.AdSoyad +  " kullanıcı adınız '" + uye.KullaniciAdi + "' parolanız '" + uye.Parola +  "' şeklindedir. Bu bilgileri kullanıp siteye giriş yapabilirsiniz.";
            try
            {
                Util.SendEmail("Şifre Hatırlatma", body, txtSifreEposta.Text); lblSifreInfo.Text = "Şifreniz e-posta adresinize gönderilmiştir. ";
            }
            catch (Exception ex)
            {
                lblSifreInfo.Text = "e-posta gönderimi sırasında hata meydana geldi." + ex.Message;
            }
        }
    }
}