﻿<%@ Page Language="C#" %> 
 
<%@ Import Namespace="System.Data" %> 
<%@ Import Namespace="System.Data.SqlClient" %> 
<html> 
<head id="Head1" runat="server"> 
 
    <script runat="server"> 
        SqlConnection con = new SqlConnection(ConfigurationManager.ConnectionStrings["Constr"].ToString()); 
        SqlCommand cmd = new SqlCommand(); 
        DataView dv = new DataView(); 
 
        DataTable dt = new DataTable(); 
        DataTable dtsort = new DataTable(); 
 
        private DataTable DataTable 
        { 
            get { return (DataTable)Session["DataTable"]; } 
            set { Session["DataTable"] = value; } 
        } 
        private DataView DataView 
        { 
            get { return (DataView)Session["DataView"]; } 
            set { Session["DataView"] = value; } 
        } 
        protected override void OnLoad(EventArgs e) 
        { 
            base.OnLoad(e); 
            if (!this.IsPostBack) 
            { 
                DataTable dt; 
                if (this.DataTable == null) 
                    LoadDataToTable(); 
                else dt = this.DataTable; 
                this.txtNumber.Attributes.Add("onkeyup", string.Format("javascript:__doPostBack('{0}','')", this.upnlGridView.ClientID)); 
                this.txtCaller.Attributes.Add("onkeyup", string.Format("javascript:__doPostBack('{0}','')", this.upnlGridView.ClientID)); 
                this.txtAnsweredBy.Attributes.Add("onkeyup", string.Format("javascript:__doPostBack('{0}','')", this.upnlGridView.ClientID)); 
            } 
            else 
            { 
                string target = this.Request.Form["__EVENTTARGET"]; 
                if (!string.IsNullOrEmpty(target) && target.Equals(this.upnlGridView.ClientID)) 
                { 
                    if (!string.IsNullOrEmpty(this.txtNumber.Text)) 
                    { 
                        Filter(); 
                    } 
                    else 
                    { 
                        this.grvItems.DataSource = this.DataTable; 
                        this.grvItems.DataBind(); 
                    } 
                } 
            } 
        } 
        private void Filter() 
        { 
            if (!string.IsNullOrEmpty(this.txtNumber.Text)) 
            { 
                DataRow[] rows = this.DataTable.Select(string.Format("Number LIKE '%{0}%'", this.txtNumber.Text)); 
                this.grvItems.DataSource = this.LoadData(rows); 
                this.grvItems.DataBind(); 
            } 
        } 
        private void LoadDataToTable() 
        { 
            con.Open(); 
            cmd.Connection = con; 
            cmd.CommandText = "select * from Call_Detail"; 
            cmd.CommandType = System.Data.CommandType.Text; 
            using (SqlDataReader reader = cmd.ExecuteReader()) 
            { 
                if (reader.HasRows) 
                { 
                    dt = new DataTable(); 
                    dt.Load(reader); 
                } 
            } 
            this.grvItems.DataSource = dt; 
            this.grvItems.DataBind(); 
            Session["DataTable"] = dt; 
        } 
        protected void PageIndexChanging(object sender, GridViewPageEventArgs e) 
        { 
 
        } 
        protected void Sorting(object sender, GridViewSortEventArgs e) 
        { 
            BindData(e.SortExpression); 
        } 
 
        private void BindData(string sortExpression) 
        { 
            // reset the dataview, else it will be undefined value! 
            dv = (DataView)Session["DataView"]; 
            if (sortExpression.Length > 0) 
            { 
                dv.Sort = sortExpression; 
                // save the dataview in stateless environment 
                Session["DataView"] = dv; 
            } 
            this.grvItems.DataSource = dv; 
            this.grvItems.DataBind(); 
        } 
        private DataTable LoadData() 
        { 
            return this.LoadData(null); 
        } 
        private DataTable LoadData(DataRow[] rows) 
        { 
            DataTable dt = this.GetTable(); 
 
            if (rows != null) 
            { 
                foreach (DataRow r in rows) 
                { 
                    dt.Rows.Add(r[0], r[1], r[2], r[3], r[4], r[5], r[6], r[7], r[8]); 
                } 
 
            } 
            dv = dt.DefaultView; 
            Session["DataView"] = dv; 
            return dt; 
        } 
        private DataTable GetTable() 
        { 
            DataTable dt = new DataTable(); 
            dt.Columns.Add("SerialNo", String.Empty.GetType()); 
            dt.Columns.Add("Date", String.Empty.GetType()); 
            dt.Columns.Add("Time", String.Empty.GetType()); 
            dt.Columns.Add("Number", String.Empty.GetType()); 
            dt.Columns.Add("Caller", String.Empty.GetType()); 
            dt.Columns.Add("Answered_By", String.Empty.GetType()); 
            dt.Columns.Add("Duration", String.Empty.GetType()); 
            dt.Columns.Add("Type", String.Empty.GetType()); 
            dt.Columns.Add("Listen", String.Empty.GetType()); 
            return dt; 
        }        
    </script> 
 
</head> 
<body> 
    <form id="form1" runat="server"> 
    <asp:ScriptManager runat="server" ID="PageScriptManager" /> 
    Search Number: 
    <asp:TextBox runat="server" ID="txtNumber" AutoPostBack="true" /> 
    Search Caller: 
    <asp:TextBox runat="server" ID="txtCaller" AutoPostBack="true" /> 
    Search AnsweredBy: 
    <asp:TextBox runat="server" ID="txtAnsweredBy" AutoPostBack="true" /> 
    <asp:UpdatePanel runat="server" ID="upnlGridView"> 
        <ContentTemplate> 
            <hr /> 
            <asp:GridView runat="server" ID="grvItems" AllowPaging="True" AllowSorting="True" 
                OnSorting="Sorting" OnPageIndexChanging="PageIndexChanging" CellPadding="5" AutoGenerateColumns="False"> 
                <Columns> 
                    <asp:BoundField DataField="SerialNo" HeaderText="Serial No" SortExpression="SerialNo" /> 
                    <asp:BoundField DataField="Date" HeaderText="Date" SortExpression="Date" /> 
                    <asp:BoundField DataField="Time" HeaderText="Time" SortExpression="Time" /> 
                    <asp:BoundField DataField="Number" HeaderText="Number" SortExpression="Number" /> 
                    <asp:BoundField DataField="Caller" HeaderText="Caller" SortExpression="Caller" /> 
                    <asp:BoundField DataField="Answered_By" HeaderText="Answered By" SortExpression="Answered_By" /> 
                    <asp:BoundField DataField="Duration" HeaderText="Duration" SortExpression="Duration" /> 
                    <asp:BoundField DataField="Type" HeaderText="Type" SortExpression="Type" /> 
                    <asp:BoundField DataField="Listen" HeaderText="Listen" SortExpression="Listen" /> 
                </Columns> 
            </asp:GridView> 
        </ContentTemplate> 
    </asp:UpdatePanel> 
    </form> 
</body> 
</html>